## adios 1.3

=== tools/matlab/Makefile ===
include ../../adios_config.flags

MEXOPTS="-g -DDEBUG"
default:
	@echo "ADIOS reader methods for MATLAB"
	@echo "Have 'mex' compiler in the path and run"
	@echo "> make matlab"


matlab: adiosopenc adiosclosec adiosreadc

adiosopenc:  
	mex adiosopenc.c ${MEXOPTS} -D_NOMPI  -I. -I../../src -L. -L../../src ${ADIOSREAD_SEQ_INC} ${ADIOSREAD_SEQ_CLIB}

adiosreadc: 
	mex adiosreadc.c ${MEXOPTS} -D_NOMPI -I. -I../../src -L. -L../../src ${ADIOSREAD_SEQ_INC} ${ADIOSREAD_SEQ_CLIB}

adiosclosec:
	mex adiosclosec.c ${MEXOPTS} -D_NOMPI -I. -I../../src -L. -L../../src ${ADIOSREAD_SEQ_INC} ${ADIOSREAD_SEQ_CLIB}

#adiosdbgc:
#	mex adiosdbgc.c ${MEXOPTS} -D_NOMPI -I. -I../../src -L. -L../../src ${ADIOSREAD_SEQ_INC} ${ADIOSREAD_SEQ_CLIB}

clean:
	rm -f *.mexa64 core* *.o 

install:
	@echo "Install *.m and *.mexa64 into MATLABPATH"
	@echo "Do not have 'adios' anywhere in the path where you install the files"
	@echo "otherwise 'help adios' will not work in Matlab"

## adios 1.2.1

=== debian/changelog ===
adios (1.2.1-2) unstable; urgency=low

  * Use MPIFC=mpif77 during build, to work on LAM-based MPI systems. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Jul 2011 00:33:10 +0100

adios (1.2.1-1) unstable; urgency=low

  * Initial release. (Closes: #624371).

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 27 Apr 2011 19:16:12 +0100

=== debian/control ===
Source: adios
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libnetcdf-dev, gfortran, libhdf5-mpi-dev | libhdf5-dev, libmxml-dev, python-all-dev, mpi-default-dev
Standards-Version: 3.9.2
Homepage: http://www.olcf.ornl.gov/center-projects/adios/

Package: libadios-dev
Section: libdevel
Architecture: any
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: ADIOS Adaptable IO system for simulations
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

BINDIR=debian/libadios-dev/usr/bin
# magic debhelper rule
%:
	dh $@ --with python2

override_dh_auto_clean:
	dh_clean
	find . -name '*.pyc' -delete

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared --prefix=`pwd`/debian/tmp  MPIFC=mpif77

override_dh_auto_install:
	$(MAKE) install prefix=$(shell pwd)/debian/libadios-dev/usr 
	chmod -x $(BINDIR)/adios_config.flags
	mv $(BINDIR)/gpp.py $(BINDIR)/gpp
	mv $(BINDIR)/gpp_types.py $(BINDIR)/gpp_types
	mv $(BINDIR)/xmlparser.py $(BINDIR)/xmlparser

## adios 1.3

=== debian/changelog ===
adios (1.3-9) unstable; urgency=low

  * Move to Standards-Version: 3.9.3. No changes required.
  * Fixes to build with hardening flags.  
  * Patch from Pino Toscano to fix FTBFS on Hurd. Closes: #660562.
  * Fix netcdf linking. Closes: #662995 
  * Change to Multiarch: foreign now we ship arch-dependent binaries
    in libadios-dev. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Mar 2012 17:34:24 +0000

adios (1.3-8) unstable; urgency=low

  * Add -Wl,--as-needed to remove unnecessary dependencies.
  * Mult-Arch support. 
    - No longer ship adios_config.flags. Instead recommend users use  
      pkg-config, which Does The Right Thing in multi-arch.
    - adios_

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Sep 2011 15:43:29 +0100

adios (1.3-7) unstable; urgency=low

  * Rename gpp to adiosxml2h. (Will be renamed by upstream in next release)
    Closes: #639257. 
  * Move DH_COMPAT=8 

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Aug 2011 18:17:09 +0100

adios (1.3-6) unstable; urgency=low

  * LAM uses mpicc.lam, not mpicc.  

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Aug 2011 17:18:36 +0100

adios (1.3-5) unstable; urgency=low

  * MPI_IN_PLACE patch is needed for adiso_mpi_lustre.c too, even though
   Lustre is not used in LAM environment. Sigh.  

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Aug 2011 09:57:26 +0100

adios (1.3-4) unstable; urgency=low

  * Patch to stop compilation with dummy MPI if real parallel HDF5 is used.
    Closes: #637893. 
  * make use of MPI_IN_PLACE conditional on MPI_IN_PLACE existing,
    as its not present in LAM MPI. Also, conditionally use mpicc.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Aug 2011 17:57:34 +0100

adios (1.3-3) unstable; urgency=low

  * Make lustre support conditional to intel,amd64, powerpc archs. 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 15 Aug 2011 16:56:23 +0100

adios (1.3-2) unstable; urgency=low

  * Set CC=mpicc to ensure new C code gets built with MPI. 
    Closes: #637714. 
  * Add lustre support. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 14 Aug 2011 16:12:14 +0100

adios (1.3-1) unstable; urgency=low

  * New upstream release.
  * Ignore -little flag in configure to support SH4. 
    Thanks to Nobuhiro Iwamatsu; Closes: #635908. 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Aug 2011 20:32:58 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,15 @@
 Section: science
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), libnetcdf-dev, gfortran, libhdf5-mpi-dev | libhdf5-dev, libmxml-dev, python-all-dev, mpi-default-dev
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8.1.3~), libnetcdf-dev, gfortran, libhdf5-mpi-dev | libhdf5-dev, libmxml-dev, python-all-dev, mpi-default-dev, 
+ lustre-dev [i386 amd64 ia64 powerpc]
+Standards-Version: 3.9.3
 Homepage: http://www.olcf.ornl.gov/center-projects/adios/
 
 Package: libadios-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: foreign
 Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
 Description: ADIOS Adaptable IO system for simulations
  The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Cope with lam not providing mpicc.
include /usr/share/mpi-default-dev/debian_defaults 
ifeq ($(ARCH_DEFAULT_MPI_IMPL),lam)
  CC:=mpicc.lam
else
  CC:=mpicc
endif

ARCH:=$(shell dpkg --print-architecture)
WITH_LUSTRE := 

ifeq ($(ARCH), i386) 
  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), amd64)
  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), powerpc) 
  WITH_LUSTRE:= --with-lustre=/usr
endif
ifeq ($(ARCH), ia64) 
  WITH_LUSTRE:= --with-lustre=/usr
endif

BINDIR=debian/libadios-dev/usr/bin
# magic debhelper rule
%:
	dh $@ --with python2

override_dh_auto_clean:
	dh_clean
	find . -name '*.pyc' -delete

override_dh_auto_configure:
	LDFLAGS=" -Wl,--as-needed" dh_auto_configure --  $(WITH_LUSTRE) --enable-shared --prefix=`pwd`/debian/tmp  MPIFC=mpif77 CC=$(CC)

override_dh_auto_install:
	$(MAKE) install prefix=$(shell pwd)/debian/libadios-dev/usr 
	# remove due to it not working in multi-arch;
	rm -f  $(BINDIR)/adios_config.flags
	# renamed as per Adios CCS issue #118716, Debbug #639257
	mv $(BINDIR)/gpp.py $(BINDIR)/adiosxml2h
	cp debian/adios_config $(BINDIR)/adios_config
	mv $(BINDIR)/gpp_types.py $(BINDIR)/gpp_types
	mv $(BINDIR)/xmlparser.py $(BINDIR)/xmlparser

## adios 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)
project(ADIOS_PROJECT)

#set(LANGUAGE "" CACHE FILEPATH "")  #C/CXX/Fortran

#enable_language(${LANGUAGE})
#message(STATUS "CMAKE_${LANGUAGE}_COMPILER_WORKS = ${CMAKE_${LANGUAGE}_COMPILER_WORKS}")

include_directories(${PROJECT_SOURCE_DIR})
link_directories(${PROJECT_BINARY_DIR})
#message("${PROJECT_SOURCE_DIR}")

#set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix})
set(bindir ${exec_prefix}/bin)
#set(datadir ${prefix}/share)
set(libdir ${exec_prefix}/lib)
set(includedir ${prefix}/include)

if(DEFINED ENV{MACRODEFFLAG})
  set(MACRODEFFLAG $ENV{MACRODEFFLAG})
else()
  set(MACRODEFFLAG "-D")
endif()
message(STATUS "MACRODEFFLAG = ${MACRODEFFLAG}")

set(LIBS "")
set(CPPFLAGS "$ENV{CPPFLAGS}")
set(CFLAGS "$ENV{CFLAGS}")
set(EXTRA_CFLAGS "$ENV{EXTRA_CFLAGS}")
set(EXTRA_LIBS "$ENV{EXTRA_LIBS}")
######## file moved from initial_cache.cmake to indicate external library is used(ON) or not (OFF)######
if(DEFINED ENV{BUILD_WRITE})
  if("$ENV{BUILD_WRITE}" STREQUAL "") 
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE $ENV{BUILD_WRITE})
  endif()
  if(BUILD_WRITE)
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_WRITE ON CACHE BOOL "")
endif()

if(DEFINED ENV{BUILD_FORTRAN})
  if("$ENV{BUILD_FORTRAN}" STREQUAL "")
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN $ENV{BUILD_FORTRAN})
  endif()
  if(BUILD_FORTRAN)
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_FORTRAN ON CACHE BOOL "")
endif()

if(DEFINED ENV{skel_timing})
  if("$ENV{skel_timing}" STREQUAL "")
    message("SKEL is not enabled")
  else()
    set(SKEL_TIMING 1)
  endif()
  if(SKEL_TIMING)
    set(SKEL_HAVE_ADIOS_TIMING True)
  else()
    set(SKEL_HAVE_ADIOS_TIMING False)
  endif()
else()
  set(SKEL_HAVE_ADIOS_TIMING False)
  message("SKEL is not enabled")
endif()
message("SKEL_HAVE_ADIOS_TIMING is ${SKEL_HAVE_ADIOS_TIMING}")

set(MXML_DIR $ENV{MXML_DIR}  CACHE FILEPATH "path to mxml dir")

set(DATATAP OFF CACHE BOOL "")

set(DIMES OFF CACHE BOOL "")

set(NSSI OFF CACHE BOOL "")

if(DEFINED ENV{SEQ_NC_DIR})
  if("$ENV{SEQ_NC_DIR}" STREQUAL "")
    set(NETCDF OFF CACHE BOOL "")
  else()
    set(NETCDF ON CACHE BOOL "")
    set(NETCDF_DIR "$ENV{SEQ_NC_DIR}" CACHE FILEPATH "path to suquential NETCDF dir")
  endif()
else()
  set(NETCDF OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PAR_NC_DIR})
  if($ENV{PAR_NC_DIR} STREQUAL "")
    set(NC4PAR OFF CACHE BOOL "")
  else()
    set(NC4PAR ON CACHE BOOL "")
    set(NC4PAR_DIR "$ENV{PAR_NC_DIR}" CACHE FILEPATH "path to parallel NETCDFdir")
  endif()
else()
  set(NC4PAR OFF CACHE BOOL "")
endif()

#if(DEFINED ENV{PAR_NC_DIR} AND DEFINED ENV{PAR_NC_CLIB})
#  set(NC4PAR ON CACHE BOOL "")
#  set(NC4PAR_DIR $ENV{PAR_NC_DIR} CACHE FILEPATH "")
#  set(NC4PAR_CPPFLAGS "-I${NC4PAR_DIR}/include")
#  set(NC4PAR_LIBS $ENV{PAR_NC_CLIB} CACHE STRING "parallel netcdf")
#else()
#  set(NC4PAR OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{SEQ_NC_DIR} AND DEFINED ENV{SEQ_NC_CLIB})
#  set(NETCDF ON CACHE BOOL "")
#  set(NETCDF_DIR $ENV{SEQ_NC_DIR} CACHE FILEPATH "")
#  set(NETCDF_CPPFLAGS "-I${NETCDF_DIR}/include")
#  set(NETCDF_LIBS $ENV{SEQ_NC_CLIB} CACHE STRING "")
#else()
#  set(NETCDF OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{PAR_HDF5_DIR} AND DEFINED ENV{PAR_HDF5_CLIB})
#  set(PHDF5 ON CACHE BOOL "")
#  set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
#  set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#  set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
#else()
#  set(PHDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{PAR_HDF5_DIR})
  if("$ENV{PAR_HDF5_DIR}" STREQUAL "")
    set(PHDF5 OFF CACHE BOOL "")
  else()
    set(PHDF5 ON CACHE BOOL "")
    set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
    set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#   set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
  endif()
else()
  set(PHDF5 OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PORTALS_DIR})
  if("$ENV{PORTALS_DIR}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS_DIR}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
elseif(DEFINED ENV{PORTALS})
  if("$ENV{PORTALS}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
else()
  set(PORTALS OFF CACHE BOOL "")
endif()

if(DEFINED ENV{DATASPACES_INCDIR})
  if("${DATASPACES_INCDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "")
  else()
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "")
endif()
if(DEFINED ENV{DATASPACES_LIBDIR})
  if("${DATASPACES_LIBDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "")
  else()
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "")
endif()
if(DEFINED DATASPACES_INCDIR)
  if(DEFINED DATASPACES_LIBDIR)
    set(DATASPACES ON CACHE BOOL "" FORCE)
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE STRING "" FORCE)
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${DATASPACES}" STREQUAL "OFF")
  if(DEFINED ENV{DATASPACES_DIR})
    set(DATASPACES ON CACHE BOOL "" FORCE)
    set(DATASPACES_DIR $ENV{DATASPACES_DIR} CACHE FILEPATH "path to dataspaces dir")
#  set(DATASPACES_LIBS "-L$ENV{DATASPACES_DIR}/libs -ldspaces -ldscommon
#  -ldar" CACHE STRING "dataspace libs")
  elseif(DEFINED ENV{DATASPACES})
    set(DATASPACES_DIR $ENV{DATASPACES} CACHE FILEPATH "path to dataspaces dir")
    set(DATASPACES ON CACHE BOOL "" FORCE)
  endif()
endif()

if(DEFINED ENV{CRAY_PMI_DIR})
  set(CRAY_PMI_DIR $ENV{CRAY_PMI_DIR})
  if(CRAY_PMI_DIR)
    set(CRAY_PMI ON CACHE BOOL "")
    set(CRAY_PMI_LIBS_PATH "${CRAY_PMI_DIR}/lib64" CACHE STRING "")
    set(CRAY_PMI_CPPFLAGS "-I${CRAY_PMI_DIR}/include" CACHE STRING "")
  else()
    set(CRAY_PMI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_PMI OFF CACHE BOOL "")
endif()

if(DEFINED ENV{CRAY_UGNI_DIR})
  set(CRAY_UGNI_DIR $ENV{CRAY_UGNI_DIR})
  if(CRAY_UGNI_DIR)
    set(CRAY_UGNI ON CACHE BOOL "")
    set(CRAY_UGNI_LIBS_PATH "${CRAY_UGNI_DIR}/lib64" CACHE STRING "")
    set(CRAY_UGNI_CPPFLAGS "-I${CRAY_UGNI_DIR}/include")
  else()
    set(CRAY_UGNI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_UGNI OFF CACHE BOOL "")
endif()

#if(DEFINED ENV{SEQ_HDF5_DIR} AND DEFINED ENV{SEQ_HDF5_CLIB})
#  set(HDF5 ON CACHE BOOL "")
#  set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
#  set(HDF5_FLAGS "-I${HDF5_DIR}/include")
#  set(HDF5_LIBS "$ENV{SEQ_HDF5_CLIB}" CACHE FILEPATH "sequential hdf5")
#else()
#  set(HDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{SEQ_HDF5_DIR})
  if("$ENV{SEQ_HDF5_DIR}" STREQUAL "")
    set(HDF5 OFF CACHE BOOL "")
  else()
    set(HDF5 ON CACHE BOOL "" FORCE)
    set(HDF5_DIR "$ENV{SEQ_HDF5_DIR}" CACHE FILEPATH "path to hdf5 dir")
    set(HDF5_FLAGS "-I${HDF5_DIR}/include")
#  set(HDF5_LIBS "$ENV{SEQ_HDF5_CLIB}" CACHE FILEPATH "sequential hdf5")
  endif()
else()
  set(HDF5 OFF CACHE BOOL "")
endif()

set(DMALLOC OFF CACHE BOOL "")

if(DEFINED ENV{LUSTRE_DIR})
  set(LUSTRE_DIR "$ENV{LUSTRE_DIR}" CACHE FILEPATH "path to lustre dir")
  set(LUSTRE ON CACHE BOOL "")
else()
  set(LUSTRE OFF CACHE BOOL "")
endif()
###################### end of external library is used(ON) or not (OFF) ##############################


#################################### start generating config.h #######################################
set(BUILD_WITH_CMAKE 1)

INCLUDE (CheckIncludeFiles)
INCLUDE (CheckFunctionExists)

# Define to dummy `main' function (if any) required to link to the Fortran
# libraries.

# Define if F77 and FC dummy `main' functions are identical.

# Define to a macro mangling the given C identifier (in lower and upper case),
# which must not contain underscores, for linking with Fortran.
set(FC_FUNC FC_GLOBAL)

# As FC_FUNC, but for C identifiers containing underscores.
set(FC_FUNC_ FC_GLOBAL_)
# Define to 1 if your Fortran compiler doesn't accept -c and -o together.

# Define to 1 if you have the <Attributes.h> header file.
CHECK_INCLUDE_FILES(Attributes.h HAVE_ATTRIBUTES_H)

# Define to 1 if you have the `clock_gettime' function.
CHECK_FUNCTION_EXISTS(clock_gettime HAVE_CLOCK_GETTIME)

# Define if you have CRAY_PMI.
set(HAVE_CRAY_PMI 0)
if(CRAY_PMI)
  find_library(CRAY_PMI_LIBS NAMES pmi PATHS ${CRAY_PMI_LIBS_PATH})
  if(CRAY_PMI_LIBS)
    set(HAVE_CRAY_PMI 1)
#  set(LIBS "${LIBS} ${CRAY_PMI_LIBS}")
    set(CPPFLAGS "${CPPFLAGS} ${CRAY_PMI_CPPFLAGS}")
  endif()
endif()

# Define if you have CRAY_UGNI.
set(HAVE_CRAY_UGNI 0)
if(CRAY_UGNI)
  find_library(CRAY_UGNI_LIBS NAMES ugni PATHS ${CRAY_UGNI_LIBS_PATH})
  if(CRAY_UGNI_LIBS)
    set(HAVE_CRAY_UGNI 1)
#   set(LIBS "${LIBS} ${CRAY_UGNI_LIBS}")
    set(CPPFLAGS "${CPPFLAGS} ${CRAY_UGNI_CPPFLAGS}")
  endif()
endif()

# Define to 1 if you have <infiniband/verbs.h>.
CHECK_INCLUDE_FILES(infiniband/verbs.h HAVE_IBVERBS_H)

CHECK_FUNCTION_EXISTS(ibv_alloc_pd HAVE_IBVERBS)

# Define if you have the Infiniband.
set(HAVE_INFINIBAND 0)
if(HAVE_IBVERBS_H AND HAVE_IBVERBS)
  set(HAVE_INFINIBAND 1)
  set(INFINIBAND ON CACHE BOOL "") 
  set(INFINIBAND_LIBS "-libverbs")
#  set(LIBS "${LIBS} ${INFINIBAND_LIBS}")
endif()

CHECK_FUNCTION_EXISTS(PtlInit HAVE_PTLINIT)

# Define to 1 if you have <portals3.h>.
#set(HAVE_PORTALS3_H 0)
CHECK_INCLUDE_FILES(portals3.h HAVE_PORTALS3_H)

# Define to 1 if you have <portals/portals3.h>.
#set(HAVE_PORTALS_PORTALS3_H 0)
CHECK_INCLUDE_FILES(portals/portals3.h HAVE_PORTALS_PORTALS3_H)

# Define to 1 if you have the <p3nal_utcp.h> header file.
CHECK_INCLUDE_FILES(p3nal_utcp.h HAVE_P3NAL_UTCP_H)

# Define to 1 if you have the <p3rt/p3rt.h> header file.
CHECK_INCLUDE_FILES(p3rt/p3rt.h HAVE_P3RT_P3RT_H)

# Define if you have the Portals.
if(PORTALS)
  set(PORTALS_LIBS "-L${PORTALS_DIR}/lib")
#  set(LIBS "${LIBS} ${PORTALS_LIBS}")
  set(PORTALS_CPPFLAGS "-I${PORTALS_DIR}/include")
  if(HAVE_PORTALS3_H)
    set(HAVE_PORTALS 1)
    set(PORTALS_CFLAGS "${PORTALS_CFLAGS} ${EXTRA_CFLAGS}")
    set(CFLAGS "${CFLAGS} ${PORTALS_CFLAGS}")
    set(PORTALS_CPPFLAGS "${PORTALS_CPPFLAGS} ${EXTRA_CPPFLAGS}")
    set(CPPFLAGS "${CPPFLAGS} ${PORTALS_CPPFLAGS}")
  elseif(HAVE_PORTALS_PORTALS3_H)
    set(HAVE_PORTALS 1)
    set(PORTALS_CFLAGS "${PORTALS_CFLAGS} ${EXTRA_CFLAGS}")
    set(CFLAGS "${CFLAGS} ${PORTALS_CFLAGS}")
    set(PORTALS_CPPFLAGS "${PORTALS_CPPFLAGS} ${EXTRA_CPPFLAGS}")
    set(CPPFLAGS "${CPPFLAGS} ${PORTALS_CPPFLAGS}") 
 endif()
#else()
#  find_package(TPLPortals) 
#  if(TPLPortals_FOUND)
#    set(PORTALS ON CACHE BOOL "" FORCE)
#    set(HAVE_PORTALS 1)
#    set(PORTALS_CPPFLAGS "${TPLPortals_INCLUDE_DIRS}")
#    set(CPPFLAGS "${CPPFLAGS} ${PORTALS_CPPFLAGS}")
#    set(PORTALS_LIBS "${TPLPortals_LIBRARIES}")
#    set(LIBS "${LIBS} ${PORTALS_LIBS}")
#  else()
#    set(HAVE_PORTALS 0)
#  endif()
endif()


# Define to 1 if you have the <dataspaces.h> header file.
set(HAVE_DATASPACES_H 0)
if(DATASPACES)
  if(DEFINED DATASPACES_INCDIR)  
    if("${DATASPACES_INCDIR}" STREQUAL "")
      set(DATASPACES_INCDIR "$ENV{DATASPACES_DIR}/include")
    endif()
  else()
    set(DATASPACES_INCDIR "$ENV{DATASPACES_DIR}/include")
  endif()
#  message(STATUS "DATASPACES_INCDIR is: ${DATASPACES_INCDIR}")
  find_path(DATASPACES_INCLUDE_DIR NAMES dataspaces.h PATHS ${DATASPACES_INCDIR})
  if(DATASPACES_INCLUDE_DIR)
    set(HAVE_DATASPACES_H 1)
    set(DATASPACES_CPPFLAGS "-I${DATASPACES_INCLUDE_DIR}")
    include_directories(${DATASPACES_INCLUDE_DIR})

=== src/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_BINARY_DIR})
link_directories(${PROJECT_BINARY_DIR}/src)

if(HAVE_NSSI)
  add_executable(nssi-staging-server nssi/nssi_staging_server.cpp nssi/aggregation.cpp)
  set_target_properties(nssi-staging-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-staging-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})

  add_executable(nssi-coupling-server nssi/nssi_coupling_server.cpp)
  set_target_properties(nssi-coupling-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL") 
  target_link_libraries(nssi-coupling-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})
endif(HAVE_NSSI)

set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

set(libadiosread_a_CPPFLAGS "")
set(libadiosreadf_a_CPPFLAGS "")
set(libadiosread_nompi_a_CPPFLAGS "")
set(libadiosreadf_nompi_a_CPPFLAGS "")

set(libadiosread_a_CFLAGS "")
set(libadiosreadf_a_CFLAGS "")
set(libadiosread_nompi_a_CFLAGS "")
set(libadiosreadf_nompi_a_CFLAGS "")

#start adios.a and adios_nompi.a
if(BUILD_WRITE)
  set(libadios_a_SOURCES core/adios.c 
                     core/common_adios.c
                     core/adios_internals.c
                     core/adios_internals_mxml.c 
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/globals.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/util.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c
                     write/adios_mpi.c
                     write/adios_mpi_lustre.c
                     write/adios_mpi_amr.c
                     write/adios_posix.c
                     write/adios_posix1.c
                     write/adios_var_merge.c)

set(libadios_nompi_a_SOURCES core/adios.c 
                     core/common_adios.c 
                     core/adios_internals.c 
                     core/adios_internals_mxml.c 
                     core/buffer.c 
                     core/adios_bp_v1.c  
                     core/adios_endianness.c 
                     core/bp_utils.c 
                     core/futils.c 
                     core/adios_error.c 
                     core/adios_read.c 
                     core/adios_read_v1.c 
                     core/common_read.c 
                     core/globals.c 
                     core/mpidummy.c 
                     core/adios_timing.c 
                     core/adios_read_hooks.c 
                     core/adios_transport_hooks.c 
                     core/adios_socket.c 
                     core/adios_logger.c 
                     core/util.c 
                     read/read_bp.c 
                     read/read_bp_staged.c 
                     read/read_bp_staged1.c 
                     write/adios_posix.c 
                     write/adios_posix1.c)

#start adiosf.a and adiosf_v1.a
  if(BUILD_FORTRAN)
    set(FortranLibSources core/adiosf.c 
                       core/common_adios.c 
                       core/adios_internals.c 
                       core/adios_internals_mxml.c
                       core/buffer.c 
                       core/adios_bp_v1.c  
                       core/adios_endianness.c
                       core/futils.c 
                       core/adios_error.c 
                       core/bp_utils.c                
                       core/common_read.c 
                       core/globals.c 
                       core/adios_timing.c 
                       core/adios_read_hooks.c 
                       core/adios_transport_hooks.c 
                       core/adios_socket.c 
                       core/adios_logger.c 
                       core/util.c 
                       read/read_bp.c 
                       read/read_bp_staged.c 
                       read/read_bp_staged1.c 
                       write/adios_posix.c 
                       write/adios_posix1.c)

    set(FortranLibMPISources write/adios_mpi.c
                         write/adios_mpi_lustre.c
	                 write/adios_mpi_amr.c
                         write/adios_var_merge.c)

    set(FortranLibSEQSources core/mpidummy.c)
  endif(BUILD_FORTRAN)

  set(libadios_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
  set(libadios_a_CFLAGS "${ADIOSLIB_CFLAGS}")
  set(libadios_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}") 
  set(libadios_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")
  set(libadiosf_a_CPPFLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS}")
  set(libadiosf_a_CFLAGS "${ADIOSLIB_CFLAGS}")
  set(libadiosf_nompi_a_CPPFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_SEQ_CPPFLAGS}")
  set(libadiosf_nompi_a_CFLAGS "${MACRODEFFLAG}_NOMPI ${ADIOSLIB_SEQ_CFLAGS}")

  if(HAVE_DATASPACES)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
    set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_dataspaces.c read/read_dataspaces.c)
    if(BUILD_FORTRAN)  
      set(FortranLibSources ${FortranLibSources} write/adios_dataspaces.c read/read_dataspaces.c)
    endif(BUILD_FORTRAN) 
  endif(HAVE_DATASPACES)

  if(HAVE_DIMES)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_dimes.c read/read_dimes.c)
    set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_dimes.c read/read_dimes.c)
    if(BUILD_FORTRAN)  
      set(FortranLibSources ${FortranLibSources} write/adios_dimes.c read/read_dimes.c)
    endif(BUILD_FORTRAN)
  endif(HAVE_DIMES)

  if(HAVE_DATATAP)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_datatap.c read/read_datatap.c)
    set(libadios_nompi_a_SOURCES ${libadios_nompi_a_SOURCES} write/adios_datatap.c read/read_datatap.c)
    if(BUILD_FORTRAN)
      set(FortranLibSources ${FortranLibSources} write/adios_datatap.c read/read_datatap.c)
    endif(BUILD_FORTRAN)
  endif(HAVE_DATATAP)

  if(HAVE_PHDF5)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_phdf5.c)
    set(PHDF5_FLAGS "${PHDF5_FLAGS} ${MACRODEFFLAG}PHDF5 ${MACRODEFFLAG}H5_USE_16_API")
    set(libadios_a_CPPFLAGS "${libadios_a_CPPFLAGS} ${PHDF5_FLAGS}")
    if(BUILD_FORTRAN)
      set(FortranLibMPISources ${FortranLibMPISources} write/adios_phdf5.c)
      set(libadiosf_a_CPPFLAGS "${libadiosf_a_CPPFLAGS} ${PHDF5_FLAGS}")
    endif(BUILD_FORTRAN) 
  endif(HAVE_PHDF5)

  if(HAVE_NC4PAR)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_nc4.c)
    if(BUILD_FORTRAN)
      set(FortranLibMPISources ${FortranLibMPISources} write/adios_nc4.c)
    endif(BUILD_FORTRAN)
  endif(HAVE_NC4PAR)

  if(HAVE_FLEXPATH)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_flexpath.c read/read_flexpath.c)
    if(BUILD_FORTRAN)
      set(FortranLibSources ${FortranLibSources} write/adios_flexpath.c read/read_flexpath.c)
    endif(BUILD_FORTRAN)
  endif(HAVE_FLEXPATH)

  if(HAVE_NSSI)
    set(dist_libadios_a_SOURCES  nssi/adios_nssi_args.x)
    set(nodist_libadios_a_SOURCES adios_nssi_args.c adios_nssi_args.h)
    set(libadios_a_SOURCES ${libadios_a_SOURCES} ${dist_libadios_a_SOURCES} ${nodist_libadios_a_SOURCES})
    set(libadios_a_SOURCES ${libadios_a_SOURCES} nssi/adios_nssi_config.c write/adios_nssi.c nssi/adios_nssi_filter.c read/read_nssi.c)
    set(libadios_a_CPPFLAGS "${libadios_a_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL")
    if(BUILD_FORTRAN)
      set(nodist_libadiosf_a_SOURCES adios_nssi_args.c adios_nssi_args.h)
      set(dist_libadiosf_a_SOURCES nssi/adios_nssi_args.x)
      set(libadiosf_a_SOURCES ${libadiosf_a_SOURCES} ${nodist_libadiosf_a_SOURCES} ${dist_libadiosf_a_SOURCES})
      set(FortranLibSources ${FortranLibSources} nssi/adios_nssi_config.c write/adios_nssi.c nssi/adios_nssi_filter.c read/read_nssi.c)
      set(libadiosf_a_CPPFLAGS "${libadiosf_a_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL")
    endif(BUILD_FORTRAN)

#adios_nssi_config.c: adios_nssi_args.c
#use include_directories(${PROJECT_BINARY_DIR}/src) to let adios_nssi_config.c
#find the header needed

    add_custom_command (
	OUTPUT adios_nssi_args.h
	COMMAND rm -f $@
	COMMAND rpcgen -h ${PROJECT_SOURCE_DIR}/src/nssi/adios_nssi_args.x >> $@
        DEPENDS ${PROJECT_SOURCE_DIR}/src/nssi/adios_nssi_args.x ${PROJECT_SOURCE_DIR}/src/CMakeLists.txt
        )

    add_custom_command (
        OUTPUT adios_nssi_args.c
        COMMAND rm -f adios_nssi_args.c
	COMMAND rpcgen -c ${PROJECT_SOURCE_DIR}/src/nssi/adios_nssi_args.x | grep -v "include \"\.\." > adios_nssi_args.c
        DEPENDS ${PROJECT_SOURCE_DIR}/src/nssi/adios_nssi_args.h
        )
    
  set(CLEANFILES ${CLEANFILES} adios_nssi_args.c adios_nssi_args.h)

  endif(HAVE_NSSI)


  if(RESEARCH_TRANSPORTS)
    set(libadios_a_SOURCES ${libadios_a_SOURCES}
                      write/adios_mpi_stagger.c 
                      write/adios_mpi_aggregate.c 
                      write/adios_provenance.c 
                      write/adios_mpi_cio.c 
                      write/adios_mpi_stripe.c 
                      write/adios_mpi_amr1.c 
                      write/adios_adaptive.ci)
    if(BUILD_FORTRAN)
      set(FortranLibMPISources ${FortranLibMPISources}
                          write/adios_mpi_stagger.c
                          write/adios_mpi_aggregate.c
                          write/adios_provenance.c
                          write/adios_mpi_cio.c
                          write/adios_mpi_stripe.c 
                          write/adios_mpi_amr1.c 
                          write/adios_adaptive.c)
    endif(BUILD_FORTRAN)
  else(RESEARCH_TRANSPORTS)
    set(libadios_a_CPPFLAGS "${libadios_a_CPPFLAGS} ${MACRODEFFLAG}NO_RESEARCH_TRANSPORTS")
    set(libadios_nompi_a_CPPFLAGS "${libadios_nompi_a_CPPFLAGS} ${MACRODEFFLAG}NO_RESEARCH_TRANSPORTS")
    set(libadiosf_a_CPPFLAGS "${libadiosf_a_CPPFLAGS} ${MACRODEFFLAG}NO_RESEARCH_TRANSPORTS")
    set(libadiosf_nompi_a_CPPFLAGS "${libadiosf_nompi_a_CPPFLAGS} ${MACRODEFFLAG}NO_RESEARCH_TRANSPORTS")
  endif(RESEARCH_TRANSPORTS)

# add library adios and adios_nompi
  add_library(adios STATIC ${libadios_a_SOURCES})
  add_library(adios_nompi STATIC ${libadios_nompi_a_SOURCES})
  set_target_properties(adios PROPERTIES COMPILE_FLAGS "${libadios_a_CPPFLAGS} ${libadios_a_CFLAGS}")
  set_target_properties(adios_nompi PROPERTIES COMPILE_FLAGS "${libadios_nompi_a_CPPFLAGS} ${libadios_nompi_a_CFLAGS}")
#  message(STATUS "${libadios_a_CPPFLAGS}")
#  message(STATUS "${libadios_a_CFLAGS}")

# Build four different Fortran libraries, for the two read APIs
# and their sequential versions
  if(BUILD_FORTRAN)
    set(libadiosf_a_SOURCES ${libadiosf_a_SOURCES} ${FortranLibSources} ${FortranLibMPISources} core/adiosf_read.c)
    set(libadiosf_v1_a_SOURCES ${FortranLibSources} ${FortranLibMPISources} core/adiosf_read_v1.c)
    set(libadiosf_nompi_a_SOURCES ${FortranLibSources} ${FortranLibSEQSources} core/adiosf_read.c)

=== tests/CMakeLists.txt ===
set(SUITEDIR suite)
if(BUILD_WRITE)
  if(BUILD_FORTRAN)
    add_subdirectory(C)
    add_subdirectory(Fortran)
    add_subdirectory(genarray)
    add_subdirectory(bp_read)
    add_subdirectory(${SUITEDIR})
  else(BUILD_FORTRAN)
    add_subdirectory(C)
    add_subdirectory(bp_read)
    add_subdirectory(${SUITEDIR})
  endif(BUILD_FORTRAN)
endif(BUILD_WRITE)

#find_library(ADIOS_LIB adios ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_LIB}-NOTFOUND)
 # message(STATUS "cannot find adios.a in ${PROJECT_BINARY_DIR}/tests makefile")
#endif(${ADIOS_LIB}-NOTFOUND)

#if(BUILD_FORTRAN)
#  find_library(ADIOSREAD_LIB NAMES adiosreadf PATHS ${PROJECT_BINARY_DIR}/src)
#  find_library(ADIOSREAD_V1_LIB NAMES adiosreadf_v1 PATHS ${PROJECT_BINARY_DIR}/src)
#else(BUILD_FORTRAN)
#  find_library(ADIOSREAD_LIB adiosread ${PROJECT_BINARY_DIR}/src)
#  if(${ADIOSREAD_LIB}-NOTFOUND)
#    message(STATUS "cannot find adiosread.a in ${PROJECT_BINARY_DIR}/tests makefile")
#  endif(${ADIOSREAD_LIB}-NOTFOUND)
#endif(BUILD_FORTRAN)

=== utils/CMakeLists.txt ===
add_subdirectory(gpp)
add_subdirectory(bpdump)
add_subdirectory(bp2ascii)
add_subdirectory(bpsplit)
add_subdirectory(bpls)

if(BUILD_WRITE)
  add_subdirectory(adios_lint)
  add_subdirectory(bp2bp)
endif(BUILD_WRITE)

if(HAVE_HDF5)
  add_subdirectory(bp2h5)
endif(HAVE_HDF5)

if(HAVE_NETCDF)
  add_subdirectory(bp2ncd)
endif(HAVE_NETCDF)

add_subdirectory(skel)


#find_library(ADIOS_INTERNAL_NOMPI_LIB adios_internal_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios_internal_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOS_INTERNAL_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOSREAD_NOMPI_LIB adiosread_nompi ${PROJECT_BINARY_DIR}/src)
#if(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)
#  message(STATUS "cannot find adiosread_nompi.a in ${PROJECT_SOURCE_DIR}/utils")
#endif(${ADIOSREAD_NOMPI_LIB}-NOTFOUND)

#find_library(ADIOS_LIB adios ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_LIB}-NOTFOUND)
#  message(STATUS "cannot find adios.a in ${PROJECT_SOURCE_DIR}/utils makefile")
#endif(${ADIOS_LIB}-NOTFOUND)

=== examples/C/CMakeLists.txt ===
add_subdirectory(scalars)
add_subdirectory(arrays)
add_subdirectory(attributes)
add_subdirectory(manual)
add_subdirectory(global-array)
add_subdirectory(global-array-time)
add_subdirectory(read_all)
add_subdirectory(stat)
add_subdirectory(schema)
#SUBDIRS=scalars arrays attributes manual global-array global-array-time read_all stat schema

=== examples/Fortran/CMakeLists.txt ===
add_subdirectory(scalars)
add_subdirectory(arrays)
add_subdirectory(global-array)
add_subdirectory(global-array-time)

=== src/core/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR})

=== tests/C/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/C)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src)
link_directories(${PROJECT_SOURCE_DIR}/src)
link_directories(${MXML_INCLUDE_DIR}/../lib)

add_executable(adios_test_c adios_test_c.c)
target_link_libraries(adios_test_c adios ${ADIOSLIB_LDADD}) 
set(adios_test_c_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
set(adios_test_c_CFLAGS "${ADIOSLIB_CFLAGS}")
set_target_properties(adios_test_c PROPERTIES COMPILE_FLAGS "${adios_test_c_CFLAGS} ${adios_test_c_CPPFLAGS}")

#install(FILES config_c.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/C)

=== tests/Fortran/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/tests/Fortran)
link_directories(${PROJECT_BINARY_DIR}/tests/Fortran)

add_executable(adios_test_f adios_test_f.F90)
target_link_libraries(adios_test_f adiosf ${ADIOSLIB_LDADD})
set_target_properties(adios_test_f PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

#install(FILES config_fortran.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/Fortran)

=== tests/bp_read/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/bp_read)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
link_directories(${PROJECT_BINARY_DIR}/tests/bp_read)

set(genbp_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
set(genbp_CFLAGS "${ADIOSLIB_CFLAGS}")

set(bp_read_c_CPPFLAGS "-DADIOS_USE_READ_API_1 ${ADIOSLIB_CPPFLAGS}")
set(bp_read_c_CFLAGS "${ADIOSLIB_CFLAGS}")

add_executable(genbp genbp.c)
target_link_libraries(genbp adios adiosread ${ADIOSLIB_LDADD})
set_target_properties(genbp PROPERTIES COMPILE_FLAGS "${genbp_CPPFLAGS} ${genbp_CFLAGS}")

add_executable(bp_read_c bp_read_c.c)
target_link_libraries(bp_read_c adiosread ${ADIOSREADLIB_LDADD})
set_target_properties(bp_read_c PROPERTIES COMPILE_FLAGS "${bp_read_c_CPPFLAGS} ${bp_read_c_CFLAGS}")

if(BUILD_FORTRAN)
  add_executable(bp_read_f bp_read_f.F90)
  target_link_libraries(bp_read_f adiosreadf ${ADIOSREADLIB_LDADD})
  set(bp_read_f_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
  set(bp_read_f_CFLAGS "${ADIOSLIB_CFLAGS}")
  set_target_properties(bp_read_f PROPERTIES COMPILE_FLAGS "${bp_read_f_CPPFLAGS} ${bp_read_f_CFLAGS}")

  add_executable(bp_read_f_v1 bp_read_f_v1.F90)
  target_link_libraries(bp_read_f_v1 adiosreadf_v1 ${ADIOSREADLIB_LDADD})
  set(bp_read_f_v1_CPPFLAGS "${ADIOSLIB_CPPFLAGS}")
  set(bp_read_f_v1_CFLAGS "${ADIOSLIB_CFLAGS}")
  set_target_properties(bp_read_f_v1 PROPERTIES COMPILE_FLAGS "${bp_read_f_v1_CPPFLAGS} ${bp_read_f_v1_CFLAGS}")

endif(BUILD_FORTRAN)

=== tests/genarray/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/tests/genarray)
include_directories(${PROJECT_BINARY_DIR}/tests/genarray)
link_directories(${PROJECT_BINARY_DIR}/tests/genarray)

add_executable(genarray genarray.F90 gwrite_genarray.fh)
target_link_libraries(genarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(genarray2D genarray2D.F90)
target_link_libraries(genarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray copyarray.F90 gread_genarray.fh)
target_link_libraries(copyarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray2D copyarray2D.F90)
target_link_libraries(copyarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

#install(FILES genarray.xml genarray3d.xml job.ewok job2D.ewok DESTINATION ${PROJECT_BINARY_DIR}/tests/genarray) 

add_custom_command(
	OUTPUT gwrite_genarray.fh
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

add_custom_command(
        OUTPUT gread_genarray.fh 
	COMMAND rm -f gwrite_genarray.fh gread_genarray.fh 
	COMMAND ${PROJECT_SOURCE_DIR}/utils/gpp/gpp.py ${PROJECT_SOURCE_DIR}/tests/genarray/genarray3d.xml
	DEPENDS genarray3d.xml
	)

=== tests/suite/CMakeLists.txt ===
add_subdirectory(programs)

#install(FILES HOWTO-Add-new-test DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(FILES HOWTO-Run DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(PROGRAMS cleanup.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(DIRECTORY reference USE_SOURCE_PERMISSIONS DESTINATION ${PROJECT_BINARY_DIR}/tests/suite PATTERN ".svn" EXCLUDE)
#install(PROGRAMS test.sh DESTINATION ${PROJECT_BINARY_DIR}/tests/suite)
#install(DIRECTORY tests USE_SOURCE_PERMISSIONS DESTINATION ${PROJECT_BINARY_DIR}/tests/suite PATTERN ".svn" EXCLUDE)

=== debian/changelog ===
adios (1.5.0-1ubuntu7) trusty; urgency=low

  * Add more netcdf fixes.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 23:09:51 -0500

adios (1.5.0-1ubuntu6) trusty; urgency=low

  * Fix netcdf underlinkage for ppc64el.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 17:42:42 -0500

adios (1.5.0-1ubuntu5) trusty; urgency=low

  * Use pkg-config to pull in the necessary libs for ppc64el.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 13:59:27 -0500

adios (1.5.0-1ubuntu4) trusty; urgency=low

  * Rearrange yet another missing lib to link for Ubuntu/ppc64el.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 13:08:57 -0500

adios (1.5.0-1ubuntu3) trusty; urgency=low

  * Add another missing lib to link for Ubuntu/ppc64el.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 12:53:17 -0500

adios (1.5.0-1ubuntu2) trusty; urgency=low

  * Rearrange missing libs to link for Ubuntu/ppc64el.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 12:19:40 -0500

adios (1.5.0-1ubuntu1) trusty; urgency=low

  * Use dh-autoreconf for newer arches.
  * Add missing curl lib to link (and its build-dependency aligned with
    Debian sid's build), resolving FTBFS on Ubuntu.

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 27 Jan 2014 11:38:45 -0500

adios (1.5.0-1) unstable; urgency=medium

  * New upstream.
  * Standards-Version: 3.9.5
  * Include latest config.{sub,guess} 
  * New watch file.
  * Create libadios-bin for binaries.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Dec 2013 15:21:31 +0000

adios (1.4.1-1) unstable; urgency=low

  * New upstream.
  * update config.{sub,guess} for the AArch64 port. Closes: #727312.
  * Make python code python2-3 agnostic.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Oct 2013 19:27:47 +0100

adios (1.3-11) unstable; urgency=low

  * Comment out lustre support (and remove dependency) as Wheezy will not
    ship with lustre-dev. Closes: #699262.
  * Standards-Version: 3.9.4. No changes required.
  * Update debhelper dependency to 9 for multiarch.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Jan 2013 16:18:53 +0000

adios (1.3-10) unstable; urgency=low

  * Patch from Simon Ruderich for hardening flags. Closes: #663925, #663978. 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 Mar 2012 10:20:55 +0000

=== debian/control ===
Source: adios
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), libnetcdf-dev, gfortran, libhdf5-mpi-dev | libhdf5-dev, libmxml-dev, python-dev, mpi-default-dev, dh-autoreconf, libcurl4-gnutls-dev,
 libldap2-dev, heimdal-multidev, libsqlite3-dev, libsasl2-dev, libkeyutils-dev, libffi-dev, pkg-config, python3-dev
Standards-Version: 3.9.5
Homepage: http://www.olcf.ornl.gov/center-projects/adios/

Package: libadios-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:  ${misc:Depends}, ${shlibs:Depends}
Recommends: libadios-bin
Description: ADIOS Adaptable IO system for simulations
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.


Package: libadios-bin
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Architecture: any
Multi-Arch: foreign
Recommends: libadios-dev
Description: ADIOS Adaptable IO system for simulations - binaries
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .
 This package provides tools for use with ADIOS.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

# Cope with lam not providing mpicc.
include /usr/share/mpi-default-dev/debian_defaults 
ifeq ($(ARCH_DEFAULT_MPI_IMPL),lam)
  CC:=mpicc.lam
else
  CC:=mpicc
endif

ARCH:=$(shell dpkg --print-architecture)
WITH_LUSTRE := 

#ifeq ($(ARCH), i386) 
#  WITH_LUSTRE:= --with-lustre=/usr
#endif
#ifeq ($(ARCH), amd64)
#  WITH_LUSTRE:= --with-lustre=/usr
#endif
#ifeq ($(ARCH), powerpc) 
#  WITH_LUSTRE:= --with-lustre=/usr
#endif
#ifeq ($(ARCH), ia64) 
#  WITH_LUSTRE:= --with-lustre=/usr
#endif

DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
NETCDF_LIBS ?= $(shell pkg-config --libs heimdal-gssapi netcdf libffi)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
BINDIR:=$(DESTDIR)/usr/bin


# magic debhelper rule
%:
	dh $@ --with python2,python3,autoreconf

override_dh_auto_clean:
	dh_clean
	find . -name '*.pyc' -delete

override_dh_auto_configure:
	dh_auto_configure --  $(WITH_LUSTRE) --enable-shared --prefix=$(DESTDIR) MPIFC=mpif77 CC=$(CC)\
	    --with-netcdf-libs="-lm -lcurl $(NETCDF_LIBS) -lz -lidn -lrtmp -lgcrypt -lgnutls -lgssapi_krb5\
	    -llber -lldap_r -lgpg-error -ltasn1 -lp11-kit -lk5crypto -lkrb5support -lsasl2 -lkeyutils\
            -lsqlite3"

override_dh_auto_install:
	$(MAKE) install prefix=$(DESTDIR)/usr
	# remove due to it not working in multi-arch;
	rm -f  $(BINDIR)/adios_config.flags
	# renamed as per Adios CCS issue #118716, Debbug #639257
	mv $(BINDIR)/gpp.py $(BINDIR)/adiosxml2h
	mv $(BINDIR)/ad_config.py $(BINDIR)/ad_config
	mv $(BINDIR)/skel_cat.py $(BINDIR)/skel_cat
	mv $(BINDIR)/skel_extract.py $(BINDIR)/skel_extract
	cp debian/adios_config $(BINDIR)/adios_config
	# mv $(DESTDIR)/bin/xmlparser.py $(DESTDIR)/bin/xmlparser

=== debian/watch ===
version=3
http://www.olcf.ornl.gov/center-projects/adios/ .*/adios-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
